#Compile Exe "gbblocks3d.exe"
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production

%Unicode = 1

#Include "win32api.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo, "icons\cube.ico"
#Resource Icon xreset, "icons\reset.ico"
#Resource Icon xpoints, "icons\points.ico"
#Resource Icon xlines, "icons\lines.ico"
#Resource Icon xsurfaces, "icons\triangles.ico"
#Resource Icon xcolors, "icons\colors.ico"
#Resource Icon xcapture, "icons\capture.ico"
#Resource Icon xsettings, "icons\settings.ico"
#Resource Icon xhelp, "icons\help.ico"
#Resource Icon xdata, "icons\data.ico"

#Resource Icon xopen, "icons\open.ico"
#Resource Icon xsave, "icons\save.ico"
#Resource Icon xdata, "icons\data.ico"

#Resource Wave, camera, "files\camera.wav"

$Ver = "1.0"
Type PointX
    X As Single
    Y As Single
    Z As Single
    Xo As Single
    Yo As Single
    Zo As Single
    Xp As Single
    Yp As Single
    Color As Long
    ColorG As Long
End Type

Type TriangleX
    p1 As Long
    p2 As Long
    p3 As Long
    ZDepthO As Single
    Color As Long
    ColorG As Long
    ZDepth As Single
    DotProduct As Single
End Type

Type Cube
    P1 As PointX
    P2 As PointX
    P3 As PointX
    P4 As PointX
    P5 As PointX
    P6 As PointX
    P7 As PointX
    P8 As PointX
    Color As Long
End Type

Type Polypoints
    Count As Long
    x1 As Single
    y1 As Single
    x2 As Single
    y2 As Single
    x3 As Single
    y3 As Single
End Type

Type CustomColors : c(15) As Long : End Type

Type ImportSceneData
   x0 As Long   'coordinates of bottom/upper/left
   y0 As Long   'coordinates of bottom/upper/left
   z0 As Long   'coordinates of bottom/upper/left
   w As Long   'box x length
   h As Long   'box y length
   z As Long   'height
   clr As Long  'color
   trans As Long 'transparency
   shape As Long 'block, cylinder, sphere, line (narrow block)
   hide As Long
   unusedA As Long
   unusedB As Long
   unusedC As Long
   'imgFileName - not required in UDT but can test to see if available. avoids 256 char limits
End Type

Enum Equates Singular
   IDC_Graphic = 500
   IDC_Toolbar
   IDC_StatusBar
   IDC_TextBox
   IDC_Label

   IDT_X
   IDT_Y
   IDT_Z
   IDT_Reset
   IDT_Points
   IDT_Lines
   IDT_Surfaces
   IDT_CycleBGColor
   IDT_Capture
   IDT_Settings
   IDT_ShowData

   IDT_Open
   IDT_Save
   IDT_SaveAs
   IDT_Help

   IDM_PGradient
   IDM_ShowLines
   IDM_AutoScale
   IDM_Angle
   IDM_PointSize
   IDM_BGColor
   IDM_PointColor
   IDM_LineColor
   IDM_TriangleColor
   IDM_DefaultColors
   IDM_BackFace
   IDM_DepthSort
   IDM_RotateAboutXAxis
   IDM_RotateAboutYAxis
   IDM_Sphere
   IDM_Test
   IDM_HideBlockOne

   IDM_TGradient
   IDM_TBlocks
   IDM_TDefault

   IDM_ApplySceneData
   IDM_ReloadSceneDataFile

   IDM_RotateUp
   IDM_RotateDown
   IDM_RotateLeft
   IDM_RotateRight

   IDM_ZoomIn
   IDM_ZoomOut

   IDM_MoveUp
   IDM_MoveDown
   IDM_MoveLeft
   IDM_MoveRight

   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete

   IDM_Sep

   TGradient = 0
   TBlocks
   TDefault
End Enum

%IDC_XMax = 521 : %IDC_XMin = 522 : %IDC_XStep = 523
%IDC_Title = 527    : %IDC_YMax = 524 : %IDC_YMin = 525 : %IDC_YStep = 526

Global hDlg, hGraphic, hToolbar, hSettings, hColors,hLst, hContext,hContextShort As Dword
Global P(), POnly() As PointX, T() As TriangleX, OriginalPT As String
Global OffsetX, OffsetY, POV, Angle As Single
Global PointSize, RotateX, RotateY, DisplayType, BackFace, DepthSort, HideBlockOne As Long  'flags
Global BColor, BackColor, PGradient, ShowData,hFont,hFontB,OrigTextProc, OrigGraphicProc,ShowLines As Long
Global LineColor, PointColor, TriangleColor, TColorScheme, BlockExtCount, AutoScale As Long
Global CustomColorList As CustomColors, D() As ImportSceneData, Cubes() As Cube
Global XHigh, XLow, YHigh, YLow, ZHigh, ZLow, THigh, TLow, FarthestPoint As Single
Global  xPoints(), yPoints(), zPoints() As Long, CurrentRX, CurrentRY, RXOffset, RYOffset As Single
Global CurrentFileName As WStringZ * %Max_Path

Function PBMain()
    Local style&
    style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
         Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop

    Dialog New Pixels, 0, "gbBlocks3D  " + $ver,,, 480,350, %WS_OverlappedWindow Or %WS_ClipChildren, To hDlg
    Dialog Set Icon hDlg, "logo"
    AddToolbar
    Control Add Graphic, hDlg, %IDC_Graphic, "", 0,60,480,290, %SS_Notify
    Control Handle hDlg, %IDC_Graphic To hGraphic
    Graphic Attach hDlg, %IDC_Graphic, ReDraw
    Control Add Statusbar, hDlg, %IDC_StatusBar,"",0,0,0,0
    Statusbar Set Text hDlg, %IDC_StatusBar, 1,0,"Hello"
    Control Add TextBox, hDlg, %IDC_TextBox, "", 5,85,195,200, style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
    Control Add Label, hDlg, %IDC_Label, "Scene Data", 15,65,150,20
    Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local iReturn, XDelta,YDelta As Long, pt As Point, temp$
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr, rc As Rect
   Static SpinInWork,XLast,YLast As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         CreateSubFolders
         Font New "Tahoma",10,0 To hFont
         Font New "Tahoma",10,1 To hFontB
         Control Set Font hDlg, %IDC_Toolbar, hFont
         Control Set Font hDlg, %IDC_TextBox, hFont
         Control Set Font hDlg, %IDC_Label, hFontB
         BuildAcceleratorTable
         CreateContextMenu
         Settings_INI "get"
         ManageVisibleControls
         SetMenusAndToolbar
         Graphic Color %Black, BColor
         temp$ = Command$
         If Len(temp$) And IsFile(temp$) Then CurrentFileName = LCase$(temp$)
         If IsFalse(IsFile(CurrentFileName)) Then CurrentFileName = "<sphere>"
         Select Case PathName$(Extn,CurrentFileName)
            Case ""   'no file name provided in Command$
               CurrentFileName = "<sphere>"
               CreateSampleSphere
               Control Set Text hDlg, %IDC_TextBox, "<Internally Generated Sphere>
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))
            Case ".stla"
               LoadSTLAFile ((CurrentFileName))
               Control Set Text hDlg, %IDC_TextBox, "<STLA File>" + $CrLf + CurrentFileName
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))
            Case ".stlb"
               LoadSTLBFile ((CurrentFileName))
               Control Set Text hDlg, %IDC_TextBox, "<STLB File>" + $CrLf + CurrentFileName
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))
            Case Else
               If IsFile(CurrentFileName) Then
                  MousePtr 11 : LoadSceneDataFromFile : FillTextBox : BuildScenePointsTriangles : MousePtr 0
                  Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T)) + "      BlocksExt: " + Str$(BlockExtCount) + "      Blocks: " + Str$(UBound(D))
               Else
                  Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Bad File Name:  " + CurrentFileName
               End If
         End Select
         ResizeDialog : CenterModel : ScaleToFit : PipeLine
         Dialog Set Text hDlg, "gbBlocks3D  v" + $ver + "     " + CurrentFileName
         OrigTextProc     = SetWindowLong(GetDlgItem(hDlg, %IDC_TextBox), %GWL_WndProc, CodePtr(NewTextProc))   'subclass a control
         OrigGraphicProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Graphic), %GWL_WndProc, CodePtr(NewGraphicProc))   'subclass a control
         Control Set Focus hDlg, %IDC_Graphic

      Case %WM_Size
         ResizeDialog
         If AutoScale Then ScaleToFit
         PipeLine

      Case %WM_Destroy
         Settings_INI "save"
         SetWindowLong GetDlgItem(hDlg, %IDC_TextBox), %GWL_WNDPROC, OrigTextProc   'un-subclass, restore original window procedure
         SetWindowLong GetDlgItem(hDlg, %IDC_Graphic), %GWL_WNDPROC, OrigGraphicProc   'un-subclass, restore original window procedure

      Case %WM_SetCursor
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemose, lbuttonup
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               iReturn = GetDlgCtrlID (Cb.WParam)
               If iReturn = %IDC_Graphic Then
                  SpinInWork = 1
                  GetCursorPos pt                      'pt has xy screen coordinates
                  ScreenToClient hGraphic, pt       'pt now has dialog client coordinates
                  XLast = Pt.x
                  YLast = Pt.y
               End If
            Case %WM_MouseMove
               If SpinInWork Then
                  GetCursorPos pt                      'pt has xy screen coordinates
                  ScreenToClient hGraphic, pt       'pt now has dialog client coordinates
                  XDelta = XLast - Pt.x
                  YDelta = YLast - Pt.y
                  If RotateX Then RotateAboutXAxis(YDelta * 0.02)      : PipeLine
                  If RotateY Then RotateAboutYAxis(XDelta * 0.02 * -1) : PipeLine
                  XLast = pt.x
                  YLast = pt.y
               End If
            Case %WM_LButtonUp
               SpinInWork = 0
         End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_TGradient : TColorScheme = %TGradient : DrawBlocks : SetMenusAndToolbar
            Case %IDM_TBlocks   : TColorScheme = %TBlocks   : DrawBlocks : SetMenusAndToolbar
            Case %IDM_TDefault  : TColorScheme = %TDefault  : DrawBlocks : SetMenusAndToolbar

            Case %IDM_PointSize
               Select Case PointSize
                  Case 1 : PointSize = 2
                  Case 2 : PointSize = 5
                  Case 5 : PointSize = 10
                  Case 10: PointSize = 1
               End Select
               DrawBlocks

            Case %IDM_Test
                  ? "Total Points: " + Str$(UBound(P)) + "    Unique Points: " + Str$(UniquePointCount)

            Case %IDM_Sphere
               CurrentFileName = "<sphere>"
               CreateSampleSphere
               CenterModel : ScaleToFit : PipeLine
               Control Set Text hDlg, %IDC_TextBox, "<Internally Generated Sphere>
               Dialog Set Text hDlg, "gbBlock3D:  " + $ver + "<sphere>"
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))

            Case %IDT_Open
               temp$ = SelectFileToOpen
               If Len(temp$) Then
                  CurrentFileName = temp$
                  MousePtr 11
                  If LCase$(PathName$(Extn,temp$)) = ".stla" Then
                     LoadSTLAFile ((CurrentFileName))
                     Control Set Text hDlg, %IDC_TextBox, "<STLA File>" + $CrLf + CurrentFileName
                     Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))
                  ElseIf LCase$(PathName$(Extn,temp$)) = ".stlb" Then
                     LoadSTLBFile ((CurrentFileName))
                     Control Set Text hDlg, %IDC_TextBox, "<STLB File>" + $CrLf + CurrentFileName
                     Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T))
                  Else
                     LoadSceneDataFromFile
                     FillTextBox
                     BuildScenePointsTriangles
                     Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T)) + "      BlocksExt: " + Str$(BlockExtCount) + "      Blocks: " + Str$(UBound(D))
                  End If
                  ResizeDialog : CenterModel : ScaleToFit : PipeLine
                  MousePtr 0
                  Dialog Set Text hDlg, "gbBlocks3D  v" + $ver + "     " + CurrentFileName
               End If

            Case %IDT_Save   : SaveSceneDataToCurrentFileName
            Case %IDT_SaveAs : SaveAs

            Case %IDM_ApplySceneData
               MousePtr 11 : LoadSceneDataFromTextBox
               FillTextBox : BuildScenePointsTriangles : ResizeDialog : CenterModel : ScaleToFit : PipeLine : MousePtr 0
            Case %IDM_ReloadSceneDataFile
               MousePtr 11 : LoadSceneDataFromFile
               FillTextBox : BuildScenePointsTriangles : ResizeDialog : CenterModel : ScaleToFit : PipeLine :  MousePtr 0

            Case %IDM_PointColor    : PointColor = SelectColor(PointColor)    : DrawBlocks
            Case %IDM_LineColor     : LineColor = SelectColor(PointColor)     : DrawBlocks
            Case %IDM_TriangleColor : TriangleColor = SelectColor(PointColor) : DrawBlocks
            Case %IDM_DefaultColors : PointColor = %Red : LineColor = %Yellow : TriangleColor = &H80 : DrawBlocks

            Case %IDM_HideBlockOne : HideBlockOne = HideBlockOne Xor 1
               BuildScenePointsTriangles
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T)) + "      BlocksExt: " + Str$(BlockExtCount) + "      Blocks: " + Str$(UBound(D))
               CenterModel : ScaleToFit : PipeLine

            Case %IDM_DepthSort : DepthSort = DepthSort Xor 1 : SetMenusAndToolbar
            Case %IDM_BackFace  : BackFace = BackFace Xor 1 : SetMenusAndToolbar

            Case %IDM_RotateAboutXAxis : RotateX = RotateX Xor 1 : SetMenusAndToolbar
            Case %IDM_RotateAboutYAxis : RotateY = RotateY Xor 1 : SetMenusAndToolbar

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDC_Graphic
                If Cb.CtlMsg = %STN_DblClk Then ResetModel : CenterModel : ScaleToFit : PipeLine

            Case %IDT_Reset
               ResetModel : CenterModel : ScaleToFit : PipeLine

            Case %IDT_Points    :  DisplayType = 1 : PipeLine : SetMenusAndToolbar
            Case %IDT_Lines     :  DisplayType = 2 : PipeLine : SetMenusAndToolbar
            Case %IDT_Surfaces  :  DisplayType = 3 : PipeLine : SetMenusAndToolbar

            Case %IDT_CycleBGColor :  CycleColors     : Graphic Color %Black, BColor  : PipeLine

            Case %IDT_ShowData
               ShowData = ShowData Xor 1 : ManageVisibleControls
               ResizeDialog : SetMenusAndToolbar
               If AutoScale Then ScaleToFit
               Pipeline
               If ShowData Then Control Set Focus hDlg, %IDC_TextBox

            Case %IDT_Capture
               Clipboard Reset
               Clipboard Set Bitmap hGraphic
               sndPlaySound "camera",%Snd_Sync Or %SND_Resource

            Case %IDT_Help
               iReturn = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbblocks3d.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_RotateLeft   : RotateAboutYAxis 0.03 * -1 : PipeLine
            Case %IDM_RotateRight  : RotateAboutYAxis 0.03 * +1 : PipeLine
            Case %IDM_RotateUp     : RotateAboutXAxis 0.03 * +1 : PipeLine
            Case %IDM_RotateDown   : RotateAboutXAxis 0.03 * -1 : PipeLine

            Case %IDM_ZoomIn  : ChangeSize +1 : PipeLine
            Case %IDM_ZoomOut : ChangeSize -1 : PipeLine

            Case %IDM_MoveUp    : MoveUp    : PipeLine
            Case %IDM_MoveDown  : MoveDown  : PipeLine
            Case %IDM_MoveLeft  : MoveLeft  : PipeLine
            Case %IDM_MoveRight : MoveRight : PipeLine

            Case %IDM_PGradient, %IDT_Settings    :  PGradient = PGradient Xor 1         : DrawBlocks : SetMenusAndToolbar
            Case %IDM_ShowLines   :  ShowLines = ShowLines Xor 1       : DrawBlocks : SetMenusAndToolbar

            Case %IDM_AutoScale
               AutoScale = AutoScale Xor 1 : SetMenusAndToolbar
               If AutoScale Then ScaleToFit : PipeLine

            Case %IDM_BGColor       :  BackColor = GetColor (BColor)  : BColor = BackColor : Graphic Color %Black, BColor : PipeLine 'point
            Case %IDM_PointColor    :  PointColor = GetColor (PointColor)        : PipeLine 'point
            Case %IDM_LineColor     :  LineColor = GetColor (LineColor)          : PipeLine 'line
            Case %IDM_TriangleColor :  TriangleColor = GetColor (TriangleColor)  : PipeLine 'planes

            Case %IDM_RotateAboutXAxis :  RotateX = RotateX Xor 1
            Case %IDM_RotateAboutYAxis :  RotateY = RotateY Xor 1

         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                 Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_CycleBGColor
                       Call TrackPopupMenu (hColors, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_X To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         PTT = Cb.LParam
                         @PTT.@lpszText = SetToolTips(Cb.NmId)
                  End Select
           End Select
   End Select
End Function

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(21)
   ac(cc).fvirt = %FVIRTKEY  : ac(cc).key   = %VK_F1          : ac(cc).cmd = %IDT_Help      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_A  : ac(cc).cmd = %IDM_ApplySceneData : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_C  : ac(cc).cmd = %IDT_Capture   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_D  : ac(cc).cmd = %IDT_ShowData  : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_G  : ac(cc).cmd = %IDM_PGradient    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_H  : ac(cc).cmd = %IDM_HideBlockOne : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_O  : ac(cc).cmd = %IDT_Open      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_P  : ac(cc).cmd = %IDM_PointSize : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_R  : ac(cc).cmd = %IDT_Reset     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_S  : ac(cc).cmd = %IDT_Save      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_T  : ac(cc).cmd = %IDM_Sphere    : Incr cc

   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key =%VK_Z  : ac(cc).cmd = %IDM_Test      : Incr cc

   ac(cc).fvirt = %FVIRTKEY Or %FControl : ac(cc).key   = %VK_Up           : ac(cc).cmd = %IDM_RotateUp      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FControl : ac(cc).key   = %VK_Down         : ac(cc).cmd = %IDM_RotateDown    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FControl : ac(cc).key   = %VK_Left         : ac(cc).cmd = %IDM_RotateLeft    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FControl : ac(cc).key   = %VK_Right        : ac(cc).cmd = %IDM_RotateRight   : Incr cc

   ac(cc).fvirt = %FVIRTKEY Or %FShift : ac(cc).key   = %VK_Up     : ac(cc).cmd = %IDM_MoveUp      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FShift : ac(cc).key   = %VK_Down   : ac(cc).cmd = %IDM_MoveDown    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FShift : ac(cc).key   = %VK_Left   : ac(cc).cmd = %IDM_MoveLeft    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FShift : ac(cc).key   = %VK_Right  : ac(cc).cmd = %IDM_MoveRight   : Incr cc

   ac(cc).fvirt = %FVIRTKEY : ac(cc).key   = %VK_Add          : ac(cc).cmd = %IDM_ZoomIn        : Incr cc
   ac(cc).fvirt = %FVIRTKEY : ac(cc).key   = %VK_Subtract     : ac(cc).cmd = %IDM_ZoomOut       : Incr cc

   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open          : Function = "Open Existing gbBlocks3D File"
      Case %IDT_Save          : Function = "Save Currently Dislayed Scene"
      Case %IDT_SaveAs        : Function = "Save Currently Displayed Scene to a Specified File"
      Case %IDT_Reset         : Function = "Reset Model to Initial Position"

      Case %IDT_Points        : Function = "Display Points Only"
      Case %IDT_Lines         : Function = "Display Lines Only"
      Case %IDT_Surfaces      : Function = "Display Surfaces Only"

      Case %IDT_CycleBGColor  : Function = "Cycle Through/Select Colors"

      Case %IDT_Capture       : Function = "Capture the Scene Display Image to the Clipboard"
      Case %IDT_ShowData      : Function = "Display the Scene Data (TextBox)"
      Case %IDT_Settings      : Function = "Use Gradient Colors"
      Case %IDT_Help          : Function = "Open Online Help Page"
   End Select
End Function

Sub PipeLine
    Local i As Long
    Graphic Clear
    If DepthSort = 1 Then
       If DisplayType = 1 Then SortPointsByZDepth
       If DisplayType = 2 Then SortTrianglesByZDepth
       If DisplayType = 3 Then SortTrianglesByZDepth
    ElseIf DisplayType = 1 Then
       For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
    End If
    If BackFace = 1 And DisplayType = 3 Then BackFaceCulling
    ProjectToScreen
    DrawBlocks
    Graphic ReDraw
End Sub

Sub RotateAboutXAxis(Ang As Single)
   Local i As Long, NewY, NewZ As Single
   For i = 1 To UBound(P)
      NewY = P(i).Y * Cos(Ang) - P(i).Z * Sin(Ang)    'X rotation
      NewZ = P(i).Y * Sin(Ang) + P(i).Z * Cos(Ang)    'X rotation
      P(i).Y = NewY : P(i).Z = NewZ
   Next i
End Sub

Sub RotateAboutYAxis(Ang As Single)
   Local i As Long, NewX, NewZ As Single
   For i = 1 To UBound(P)
      NewX = P(i).Z * Sin(Ang) + P(i).X * Cos(Ang)    'Y rotation
      NewZ = P(i).Z * Cos(Ang) - P(i).X * Sin(Ang)    'Y rotation
      P(i).X = NewX : P(i).Z = NewZ
   Next I
End Sub

Sub SortPointsByZDepth
   Local i As Long
   For i = 1 To UBound(P) : POnly(i) = P(i) : Next i
   Array Sort POnly(1), Call CustomPointSort          'sort POnly
End Sub

Function CustomPointSort(R As PointX, S As PointX) As Long
   'sorts in ascending order by .z element
   If R.z < S.z Then Function = -1 : Exit Function
   If R.z > S.z Then Function = +1 : Exit Function
End Function

Sub SortTrianglesByZDepth
   Local i As Long
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ZDepth = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
      Next i
      Array Sort T(1), Call CustomTriangleSort
   End If
End Sub

Function CustomTriangleSort(R As TriangleX, S As TriangleX) As Long
   'sorts in ascending order by .ZDepth element
   If R.ZDepth < S.ZDepth Then Function = -1 : Exit Function
   If R.ZDepth > S.ZDepth Then Function = +1 : Exit Function
End Function

Function BackFaceCulling() As Long
    Dim i As Long
    'use CrossProduct to find normal with (0,0,POV), put in P(0)
    'get DotProduct between point of view and normal
    If UBound(T) > 0 Then
       For i = 1 To UBound(T)
          ComputeCrossProduct i
          T(i).DotProduct = ComputeDotProduct
       Next i
    End If
End Function

Sub ComputeCrossProduct(i As Long)
    Dim x1 As Single, y1 As Single, z1 As Single, x2 As Single, y2 As Single, z2 As Single
    'cross product defines a vector perpendicular to the triangle surface
    'uses right-hand rule of thumb rule, sequence of points defines the surface (counter-clockwise)
    'create position vectors to use in cross product
    'this code uses points P1P2 and P2P3 line segments
    'any 2 line segements from the triangle will do
    x1 = P(T(i).p2).X - P(T(i).p1).X    'position vector, x component
    y1 = P(T(i).p2).Y - P(T(i).p1).Y    'position vector, y component
    z1 = P(T(i).p2).Z - P(T(i).p1).Z    'position vector, z component

    x2 = P(T(i).p3).X - P(T(i).p1).X    'position vector, x component
    y2 = P(T(i).p3).Y - P(T(i).p1).Y    'position vector, y component
    z2 = P(T(i).p3).Z - P(T(i).p1).Z    'position vector, z component

    'put resulting cross product vector in P(0) - just a conveniently unused position in the array
    P(0).X = y1 * z2 - y2 * z1     'cross product vector, x component
    P(0).Y = x2 * z1 - x1 * z2     'cross product vector, y component
    P(0).Z = x1 * y2 - x2 * y1     'cross product vector, z component
End Sub

Function ComputeDotProduct() As Long
    'uses POV vector 0,0,POV  as x1,y1,z1
    'used cross product that was stored in P(0) as x2, y2, z2
    ComputeDotProduct = 0 * P(0).X + 0 * P(0).Y + POV * P(0).Z
End Function

Function ProjectToScreen() As Long
   Local i As Long
   For i = 1 To UBound(P)
      If DisplayType = 1 Then
         POnly(i).xp = POnly(i).x
         POnly(i).yp = POnly(i).y
      Else
         P(i).xp = P(i).x
         P(i).yp = P(i).y
      End If
   Next i
End Function

Sub DrawBlocks()
   Local i,PColor,LColor,TColor As Long, x,y As Single, PTS As PolyPoints
   PTS.Count = 3
   Graphic Clear
   Select Case DisplayType
       Case 1     'points
          For i = 1 To UBound(POnly)
             If PGradient Then PColor = POnly(i).ColorG Else PColor = PointColor
             x = POnly(i).xp + OffsetX  : y = POnly(i).yp + OffsetY
             Graphic Ellipse (x-PointSize,y-Pointsize)-(x+Pointsize,y+Pointsize), PColor, PColor, 0
          Next i
       Case 2     'lines
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                Graphic Polygon PTS, LineColor, -2, 0, 0              'Graphic Polyline PTS, LineColor
             Next i
          End If
       Case 3     'surface
          If UBound(T) > 0 Then
             For i = 1 To UBound(T)
                Select Case TColorScheme
                   Case %TGradient : TColor = T(i).ColorG
                   Case %TBlocks   : TColor = T(i).Color
                   Case %TDefault  : TColor = TriangleColor
                End Select
'                If Gradient Then TColor = T(i).ColorG Else TColor = TriangleColor
                If ShowLines Then LColor = LineColor Else LColor = TColor
                PTS.x1 = P(T(i).p1).xp + OffsetX : PTS.y1 = P(T(i).p1).yp + OffsetY
                PTS.x2 = P(T(i).p2).xp + OffsetX : PTS.y2 = P(T(i).p2).yp + OffsetY
                PTS.x3 = P(T(i).p3).xp + OffsetX : PTS.y3 = P(T(i).p3).yp + OffsetY
                If (BackFace = 1 And T(i).DotProduct > 0 ) Or BackFace = 0 Then
                   Graphic Polygon PTS, LColor, TColor, 0, 0
                End If
             Next i
          End If
   End Select
   Graphic ReDraw
End Sub

Sub LoadSceneDataFromFile
   Local temp$, iCount,LineCount As Long
   Open CurrentFileName For Input As #1
   FileScan #1, Records To LineCount

   Line Input #1, temp$
   If InStr(LCase$(temp$),"gbblocks3d") = 0 Then Close #1 : Beep : Exit Sub

   ReDim D(LineCount-1)  '0-based, but position 1 not used
   XHigh=0 : YHigh=0 : ZHigh=0 : XLow=0 : YLow=0 : ZLow=0
   While IsFalse(Eof(1))
      Line Input #1, temp$
      Incr iCount
      D(iCount).x0 = Val(Parse$(temp$,",",1))
      D(iCount).y0 = Val(Parse$(temp$,",",2))
      D(iCount).z0 = Val(Parse$(temp$,",",3))
      D(iCount).w = Val(Parse$(temp$,",",4))
      D(iCount).h = Val(Parse$(temp$,",",5))
      D(iCount).z = Val(Parse$(temp$,",",6))
      D(iCount).clr = Val(Parse$(temp$,",",7))
      D(iCount).trans = Val(Parse$(temp$,",",8))

      XHigh = Max(XHigh,D(iCount).x0+D(iCount).w)
      XLow  = Min(XLow, D(iCount).x0+D(iCount).w)
      YHigh = Max(YHigh,D(iCount).y0+D(iCount).h)
      YLow  = Min(YLow, D(iCount).y0+D(iCount).h)
      ZHigh = Max(ZHigh,D(iCount).z0+D(iCount).z)
      ZLow  = Min(ZLow, D(iCount).z0+D(iCount).z)
   Wend
   Close #1
End Sub

Sub LoadSceneDataFromTextBox
   Local temp$, tmp$, i,LineCount As Long
   Control Get Text hDlg, %IDC_TextBox To tmp$
   tmp$ = Trim$(tmp$, Any $CrLf + $Spc )
   LineCount = ParseCount(tmp$,$CrLf)
   ReDim D(LineCount)  '0-based
   XHigh=0 : YHigh=0 : ZHigh=0 : XLow=0 : YLow=0 : ZLow=0
   For i = 1 To LineCount
      temp$ = Parse$(tmp$,$CrLf,i)
      D(i).x0 = Val(Parse$(temp$,",",1))
      D(i).y0 = Val(Parse$(temp$,",",2))
      D(i).z0 = Val(Parse$(temp$,",",3))
      D(i).w = Val(Parse$(temp$,",",4))
      D(i).h = Val(Parse$(temp$,",",5))
      D(i).z = Val(Parse$(temp$,",",6))
      D(i).clr = Val(Parse$(temp$,",",7))
      D(i).trans = Val(Parse$(temp$,",",8))

      XHigh = Max(XHigh,D(i).x0+D(i).w)
      XLow  = Min(XLow, D(i).x0+D(i).w)
      YHigh = Max(YHigh,D(i).y0+D(i).h)
      YLow  = Min(YLow, D(i).y0+D(i).h)
      ZHigh = Max(ZHigh,D(i).z0+D(i).z)
      ZLow  = Min(ZLow, D(i).z0+D(i).z)
   Next i
End Sub

Sub FillTextBox
   Local temp$, i As Long
   For i = 1 To UBound(D)
      temp$ = temp$ + $CrLf + LTrim$(Str$(D(i).x0)) + ", " + Str$(D(i).y0) + ", " + Str$(D(i).z0) + ", " + _
      Str$(D(i).w) + ", " + Str$(D(i).h) + ", " + Str$(D(i).z) + ", " + Str$(D(i).clr) + ", " + Str$(D(i).trans)
   Next i
   temp$ = Trim$(temp$,Any $CrLf + $Spc)
   Control Set Text hDlg, %IDC_TextBox, temp$
End Sub

Sub AddToolbar
    'add toolbar1
    Control Add Toolbar, hDlg, %IDC_Toolbar, "Toolbar",0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    'create imagelist
    ImageList New Icon 24,24,24,20 To hLst
    ImageList Add Icon hLst, "logo"            '1
    ImageList Add Icon hLst, "xreset"          '2

    ImageList Add Icon hLst, "xpoints"         '3
    ImageList Add Icon hLst, "xlines"          '4
    ImageList Add Icon hLst, "xsurfaces"       '5


    ImageList Add Icon hLst, "xcolors"         '6
    ImageList Add Icon hLst, "xsettings"       '7
    ImageList Add Icon hLst, "xhelp"           '8
    ImageList Add Icon hLst, "xcapture"        '9

    ImageList Add Icon hLst, "xsave"           '10
    ImageList Add Icon hLst, "xopen"           '11
    ImageList Add Icon hLst, "xdata"           '12

    'attach imagelist
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hLst, 0

    'create buttons
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_Open, %TbStyle_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10, %IDT_Save, %TbStyle_Button, "Save"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10, %IDT_SaveAs, %TbStyle_Button, "SaveAs"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2, %IDT_Reset, %TbStyle_Button, "Reset"

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3, %IDT_Points, %TbStyle_CheckGroup, "Points"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4, %IDT_Lines, %TbStyle_CheckGroup, "Lines"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5, %IDT_Surfaces, %TbStyle_CheckGroup, "Surfaces"

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6, %IDT_CycleBGColor, %TbStyle_DropDown, "Colors"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9, %IDT_Capture, %TbStyle_Button, "Capture"

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_ShowData, %TbStyle_Check, "Data"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7, %IDT_Settings, %TbStyle_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8, %IDT_Help, %TbStyle_Button, "Help"

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "AutoSize Drawing to Window", %IDM_AutoScale, %MF_Enabled
    Menu Add String, hSettings, "Use Gradient Colored Points", %IDM_PGradient, %MF_Enabled
    Menu Add String, hSettings, "Show Surface Lines", %IDM_ShowLines, %MF_Enabled
    Menu Add String, hSettings, "-",0,0
    Menu Add String, hSettings, "Gradient Surface Colors", %IDM_TGradient, %MF_Enabled
    Menu Add String, hSettings, "Block Surface Colors", %IDM_TBlocks, %MF_Enabled
    Menu Add String, hSettings, "Default Surface Colors", %IDM_TDefault, %MF_Enabled

    Menu Add String, hSettings, "-",0,0
    Menu Add String, hSettings, "BackFace", %IDM_BackFace, %MF_Enabled
    Menu Add String, hSettings, "DepthSort", %IDM_DepthSort, %MF_Enabled
    Menu Add String, hSettings, "-",0,0
    Menu Add String, hSettings, "Rotate About X Axis", %IDM_RotateAboutXAxis, %MF_Enabled
    Menu Add String, hSettings, "Rotate About Y Axis", %IDM_RotateAboutYAxis, %MF_Enabled
'    Menu Add String, hSettings, "Rotate Z", %IDM_RotateZ, %MF_Enabled

    Menu New PopUp To hColors
    Menu Add String, hColors, "Background Color", %IDM_BGColor, %MF_Enabled
    Menu Add String, hColors, "Point Color", %IDM_PointColor, %MF_Enabled
    Menu Add String, hColors, "Line Color", %IDM_LineColor, %MF_Enabled
    Menu Add String, hColors, "Triangle Color", %IDM_TriangleColor, %MF_Enabled
    Menu Add String, hColors, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hColors, "Restore Default Colors", %IDM_DefaultColors, %MF_Enabled


End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ * %Max_Path

   'defines file name (any file name will work)
   INIFileName = Exe.Path$ + "gbblocks3d.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "700", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "550", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "CurrentFileName", "<sphere>", CurrentFileName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "RotateX", "1",       temp, %Max_Path, INIFileName   :   RotateX = Val(temp)
      Getprivateprofilestring "All", "RotateY", "1",       temp, %Max_Path, INIFileName   :   RotateY = Val(temp)
      Getprivateprofilestring "All", "Angle", "0.02",      temp, %Max_Path, INIFileName   :   Angle = Val(temp)
      Getprivateprofilestring "All", "DisplayType", "3",   temp, %Max_Path, INIFileName   :   DisplayType  = Val(temp)
      Getprivateprofilestring "All", "DepthSort", "1",     temp, %Max_Path, INIFileName   :   DepthSort = Val(temp)
      Getprivateprofilestring "All", "BackFace", "1",      temp, %Max_Path, INIFileName   :   BackFace = Val(temp)
      Getprivateprofilestring "All", "Gradient", "0",      temp, %Max_Path, INIFileName   :   PGradient = Val(temp)
      Getprivateprofilestring "All", "BColor", "0",        temp, %Max_Path, INIFileName   :   BColor = Val(temp)
      Getprivateprofilestring "All", "BackColor", Str$(%rgb_LightBlue),  temp, %Max_Path, INIFileName  :    BackColor = Val(temp)
      Getprivateprofilestring "All", "LineColor", Str$(%Yellow),    temp, %Max_Path, INIFileName   :   LineColor = Val(temp)
      Getprivateprofilestring "All", "PointColor", Str$(%Red),      temp, %Max_Path, INIFileName   :   PointColor = Val(temp)
      Getprivateprofilestring "All", "TriangleColor", Str$(&H80),   temp, %Max_Path, INIFileName   :   TriangleColor = Val(temp)
      Getprivateprofilestring "All", "ShowLines", "1",              temp, %Max_Path, INIFileName   :   ShowLines = Val(temp)
      Getprivateprofilestring "All", "AutoScale", "1",               temp, %Max_Path, INIFileName   :   AutoScale = Val(temp)
      Getprivateprofilestring "All", "PointSize", "2",              temp, %Max_Path, INIFileName   :   PointSize = Val(temp)
      Getprivateprofilestring "All", "POV", "1000",                 temp, %Max_Path, INIFileName   :   POV = Val(temp)
      Getprivateprofilestring "All", "ShowData", "0",               temp, %Max_Path, INIFileName   :   ShowData = Val(temp)
      Getprivateprofilestring "All", "TColorScheme", Str$(%TDefault),temp, %Max_Path, INIFileName   :   TColorScheme = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Colors", "CustomColor" + Trim$(Str$(x)), "0",  temp, %Max_Path, INIFileName   :   CustomColorList.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "CurrentFileName", CurrentFileName, INIFileName

      'save numeric variable
      temp = Str$(RotateX)      : WritePrivateProfileString "All", "RotateX", temp, INIFileName
      temp = Str$(RotateY)      : WritePrivateProfileString "All", "RotateY", temp, INIFileName
      temp = Str$(Angle)        : WritePrivateProfileString "All", "Angle", temp, INIFileName
      temp = Str$(DisplayType)  : WritePrivateProfileString "All", "DisplayType", temp, INIFileName
      temp = Str$(DepthSort)    : WritePrivateProfileString "All", "DepthSort", temp, INIFileName
      temp = Str$(BackFace)     : WritePrivateProfileString "All", "BackFace", temp, INIFileName
      temp = Str$(PGradient)     : WritePrivateProfileString "All", "Gradient", temp, INIFileName
      temp = Str$(BColor)       : WritePrivateProfileString "All", "BColor", temp, INIFileName
      temp = Str$(BackColor)    : WritePrivateProfileString "All", "BackColor", temp, INIFileName
      temp = Str$(LineColor)    : WritePrivateProfileString "All", "LineColor", temp, INIFileName
      temp = Str$(PointColor)   : WritePrivateProfileString "All", "PointColor", temp, INIFileName
      temp = Str$(TriangleColor): WritePrivateProfileString "All", "TriangleColor", temp, INIFileName
      temp = Str$(ShowLines)    : WritePrivateProfileString "All", "ShowLines", temp, INIFileName
      temp = Str$(AutoScale)    : WritePrivateProfileString "All", "AutoScale", temp, INIFileName
      temp = Str$(Pointsize)    : WritePrivateProfileString "All", "PointSize", temp, INIFileName
      temp = Str$(POV)          : WritePrivateProfileString "All", "POV", temp, INIFileName
      temp = Str$(ShowData)     : WritePrivateProfileString "All", "ShowData", temp, INIFileName
      temp = Str$(TColorScheme) : WritePrivateProfileString "All", "TColorScheme", temp, INIFileName

      For x = 0 To 15
         temp = Str$(CustomColorList.c(x)): WritePrivateProfileString "Colors", "CustomColor" + Trim$(Str$(x)), temp, INIFileName
      Next x

   End If
End Sub

Sub SetPointHighLow()
   Local i As Long
   If UBound(p) = -1 Then
       XHigh = 0: XLow = 0: YHigh = 0: YLow = 0: ZHigh = 0: ZLow = 0
   Else
       XHigh = P(1).xo: XLow = P(1).xo
       YHigh = P(1).yo: YLow = P(1).yo
       ZHigh = P(1).zo: ZLow = P(1).zo
       For i = 2 To UBound(P)
           If P(i).xo > XHigh Then XHigh = P(i).xo
           If P(i).xo < XLow Then XLow = P(i).xo

           If P(i).yo > YHigh Then YHigh = P(i).yo
           If P(i).yo < YLow Then YLow = P(i).yo

           If P(i).zo > ZHigh Then ZHigh = P(i).zo
           If P(i).zo < ZLow Then ZLow = P(i).zo
       Next i
   End If
End Sub

Sub SetTriangleHighLow()
   Local i As Long
   If UBound(T) < 1 Then
       THigh = 0: TLow = 0
   Else
       T(1).ZDepthO = (P(T(1).p1).Z + P(T(1).p2).Z + P(T(1).p3).Z) / 3
       THigh = T(1).ZDepthO : TLow = T(1).ZdepthO
       For i = 2 To UBound(T)
           T(i).ZDepthO = (P(T(i).p1).Z + P(T(i).p2).Z + P(T(i).p3).Z) / 3
           If T(i).ZDepthO > THigh Then THigh = T(i).ZDepthO
           If T(i).ZDepthO < TLow Then TLow = T(i).ZDepthO
       Next i
   End If
End Sub

Sub ResetModel
   Local i As Long
   For i = 1 To UBound(P)
      P(i).x = P(i).xo : P(i).y = P(i).yo : P(i).z = P(i).zo
      POnly(i).x = P(i).xo : POnly(i).y = P(i).yo : POnly(i).z = P(i).zo
   Next i
End Sub

Sub CenterModel
   Local i As Long, CenterX, CenterY, CenterZ As Single
   CenterX = (XHigh + XLow)/2
   CenterY = (YHigh + YLow)/2
   CenterZ = (ZHigh + ZLow)/2

   'move all nodes to center position
   For i = 1 To UBound(P)
      P(i).x = (P(i).xo - CenterX) : POnly(i).x = P(i).x
      P(i).y = (P(i).yo - CenterY) : POnly(i).y = P(i).y
      P(i).z = (P(i).zo - CenterZ) : POnly(i).z = P(i).z
   Next i

End Sub

Sub ScaleToFit
   Local i,w,h As Long, sTemp As Single
   Local ScaleFactor, SMargin As Single

   SMargin = 0.95

   'get farthest point to use for setting scalefactor
   FarthestPoint = 0
   For i = 1 To UBound(P)
      sTemp = Sqr(P(i).x*P(i).x + P(i).y*P(i).y + P(i).z*P(i).z)
      If FarthestPoint < Abs(sTemp) Then FarthestPoint = Abs(sTemp)
   Next i
   Control Get Size hDlg, %IDC_Graphic To w,h
   If h < w Then ScaleFactor = h /(2*FarthestPoint)*SMargin Else ScaleFactor = w/(2*FarthestPoint)*SMargin

   'scale points to fit within graphic control
   For i = 1 To UBound(P)
      P(i).x = P(i).x * ScaleFactor : POnly(i).x = P(i).x
      P(i).y = P(i).y * ScaleFactor : POnly(i).y = P(i).y
      P(i).z = P(i).z * ScaleFactor : POnly(i).z = P(i).z
   Next i
End Sub

Sub CreateSampleSphere()
   Local i, j, iCount, TCount, iLayers, iDivisions  As Long
   Local SAngle, Radius, z, zStep, tempS As Single
   iLayers = 20 : iDivisions = 20 : Radius = 100 : iCount = 1
   ReDim P(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim POnly(iLayers * iDivisions + 2)    'position P(0) is reserved
   ReDim T((iLayers-1)*iDivisions*2 + 4*iDivisions)

   SAngle = 6.28 / iDivisions   '1 radian = 57.2957 degrees : 1 degree = 0.0174532 radians
   zStep = 2 * Radius / (iLayers+1)

   'Points
   P(iCount).x = 0 : P(iCount).y = 0 : P(iCount).z = Radius
   P(UBound(P)).x = 0 : P(UBound(P)).y = 0 : P(UBound(P)).z = -1 * Radius
   For i = 1 To iLayers
      z = Radius - zStep * i
      tempS = Sqr(Radius*Radius - z*z)
      For j = 0 To iDivisions - 1
         iCount = iCount + 1
         P(iCount).x = tempS * Sin(j*SAngle)
         P(iCount).y = tempS * Cos(j*SAngle)
         P(iCount).z = z
      Next j
   Next i

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i

   'triangles
   'top layer
   For i = 2 To iDivisions
      Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = i+1 :  T(TCount).p3 = i
   Next i
   Incr TCount  :   T(TCount).p1 = 1  :  T(TCount).p2 = 2 :  T(TCount).p3 = iDivisions + 1

   'bottom layer
   For i = UBound(P)-iDivisions To UBound(P)-1
      Incr TCount  :   T(TCount).p1 = UBound(P) :  T(TCount).p2 = i :  T(TCount).p3 = i+1
   Next i
   Incr TCount  :   T(TCount).p1 = UBound(P)  :  T(TCount).p2 = UBound(P)-1 :  T(TCount).p3 = UBound(P)-iDivisions

   'other layers
   For i = 1 To iLayers-1
      iCount = (i-1)*iDivisions + 1
      'most divisions
      For j = 1 To iDivisions -1
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + iDivisions + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions
         Incr TCount
         T(TCount).p1 = j + iCount
         T(TCount).p2 = T(TCount).p1 + 1
         T(TCount).p3 = T(TCount).p1 + iDivisions + 1
      Next j
      'last division
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount + iDivisions
      T(TCount).p3 = iCount + iDivisions + iDivisions
      Incr TCount
      T(TCount).p1 = iDivisions + iCount
      T(TCount).p2 = 1 + iCount
      T(TCount).p3 = 1 + iCount + iDivisions
   Next i
'   For i = 1 to UBound(T)
'      T(i).Color = TriangleColor
'   Next i
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub


Function GetColor(startColor As Long) As Long
   Local ColorResult&
   Display Color hDlg, 100, 100, startColor, CustomColorList, 0 To ColorResult&
   If ColorResult& = -1 Then
      Function = startColor    'startColor is returned if Cancel/Escape is pressed
   Else
      Function = ColorResult&    'used SelectedColor& as firstcolor the next time the dialog is displayed
   End If
End Function

Sub CreateOriginalPTString
    Local i As Long
    OriginalPT = "Points:"         'OriginalPT + $CrLf + $CrLf + "Points:"
    For i = 1 To UBound(P)
       OriginalPT = OriginalPT + $CrLf + Format$(P(i).x,"00") + Format$(P(i).y," 00") + Format$(P(i).z," 00")
    Next i
   OriginalPT = OriginalPT + $CrLf + $CrLf + "Triangles:"
    For i = 1 To UBound(T)
       OriginalPT = OriginalPT + $CrLf + Str$(T(i).p1) + Str$(T(i).p2) + Str$(T(i).p3)
    Next i
End Sub

Sub SetTriangleGradientColors
   Local i As Long
   If UBound(T) < 1 Then THigh = 0: TLow = 0 : Exit Sub
   SetTriangleHighLow
   If UBound(T) > 0 Then
      For i = 1 To UBound(T)
         T(i).ColorG = GradientZ(T(i).ZDepthO, THigh, TLow)
      Next i
   End If
End Sub

Sub SetPointGradientColors
   Local i As Long
   SetPointHighLow
   For i = 1 To UBound(P)
      P(i).ColorG = GradientZ(P(i).zo, ZHigh, ZLow) :  POnly(i).ColorG = P(i).ColorG
   Next i
End Sub

Function GradientZ(ZValue As Single, HiZ As Single, LoZ As Single) As Long
   'returns Long color, and RGB components, across the entire spectrum based on position of a number between two limits
   Local CRatio As Single, Exponent As Single
   Local R,G,B As Long
   Exponent = 0.365
   If HiZ <> LoZ Then
       CRatio = Abs((ZValue - LoZ) / (HiZ - LoZ))
   Else
       CRatio = 0
   End If

   If CRatio > 1 Then CRatio = 1
   If CRatio < 0 Then CRatio = 0

   Select Case CRatio
       Case Is < 0.25
           r = 0
           g = 255 * (((CRatio - 0) * 4) ^ Exponent)
           b = 255
       Case Is < 0.5
           r = 0
           g = 255
           b = 255 * ((1 - (CRatio - 0.25) * 4) ^ Exponent)
       Case Is < 0.75
           r = 255 * (((CRatio - 0.5) * 4) ^ Exponent)
           g = 255
           b = 0
       Case Else
           r = 255
           g = 255 * ((1 - (CRatio - 0.75) * 4) ^ Exponent)
           b = 0

   End Select
   Function = RGB(r, g, b)

End Function

Sub CycleColors
    Static ColorSelection As Long
    Select Case ColorSelection
       Case 0 : BColor = %rgb_Maroon
       Case 1 : BColor = %rgb_DarkGreen
       Case 2 : BColor = %rgb_DarkBlue
       Case 3 : BColor = %rgb_DimGray
       Case 4 : BColor = %Black
       Case 5 : BColor = %White
       Case 6 : BColor = BackColor
    End Select
    ColorSelection = ColorSelection + 1
    If ColorSelection > 6 Then Colorselection = 0
End Sub

Sub MoveUp
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y - 10 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveDown
    Local i As Long
    For i = 1 To UBound(P)
        P(i).y = P(i).y + 10 : POnly(i).y = P(i).y
    Next i
End Sub

Sub MoveLeft
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x - 10 : POnly(i).x = P(i).x
    Next i
End Sub

Sub MoveRight
    Local i As Long
    For i = 1 To UBound(P)
        P(i).x = P(i).x + 10 : POnly(i).x = P(i).x
    Next i
End Sub

Sub ChangeSize (Flag As Long)
    Local i As Long, Factor As Single
    Factor = (1 + 0.2 * Flag)
    For i = 1 To UBound(P)
        P(i).x = P(i).x * Factor : POnly(i).x = P(i).x
        P(i).y = P(i).y * Factor : POnly(i).y = P(i).y
        P(i).z = P(i).z * Factor : POnly(i).z = P(i).z
    Next i
End Sub

Sub BuildScenePointsTriangles

   Local i, iPos, CubeCount, Z As Long
   ReDim P(0), POnly(0), T(0), Cubes(0)
   CubeCount = UBound(D)
   ReDim Cubes(CubeCount)

   BuildCubesFromImportScene

   'get list of all xyz points
   i = UBound(Cubes) * 2 : z = 0
   ReDim xPoints(i), yPoints(i), zPoints(i) As Long

   For i = 1 To UBound(Cubes)
       z = (i-1) * 2 + 1
       xPoints(z) = Cubes(i).p1.x
       yPoints(z) = Cubes(i).p1.y
       zPoints(z) = Cubes(i).p1.z
       Incr z
       xPoints(z) = Cubes(i).p2.x
       yPoints(z) = Cubes(i).p4.y
       zPoints(z) = Cubes(i).p5.z
   Next i

   'sort the arrays
   Array Sort xpoints() : Array Sort ypoints() : Array Sort zpoints()

   'remove duplicates in xpoints, ypoints, zpoints
   iPos = 0
   For i =  UBound(xpoints) To 2 Step -1
      If xpoints(i) = xpoints(i-1) Then Array Delete xpoints(i) : Incr iPos
   Next i
   ReDim Preserve xpoints(UBound(xpoints)-iPos)

   iPos = 0
   For i = UBound(ypoints) To 2 Step -1
      If ypoints(i) = ypoints(i-1) Then Array Delete ypoints(i) : Incr iPos
   Next i
   ReDim Preserve ypoints(UBound(ypoints)-iPos)

   iPos = 0
   For i = UBound(zpoints) To 2 Step -1
      If zpoints(i) = zpoints(i-1) Then Array Delete zpoints(i) : Incr iPos
   Next i
   ReDim Preserve zpoints(UBound(zpoints)-iPos)

   'create cubes
   BlockExtCount = 0
   For i = 1 To UBound(Cubes)
      CreateSubDividedCubes Cubes(i), Cubes(i).Color
   Next i

   SetPointGradientColors
   SetTriangleGradientColors

End Sub

Sub BuildCubesFromImportScene
    Local i,w,h,z As Long
    ReDim Cubes(UBound(D))

    For i = 1 To UBound(D)
       If i = 1 And HideBlockOne Then Iterate For

       w = D(i).w
       h = D(i).h
       z = D(i).z

       Cubes(i).p1.x = D(i).x0
       Cubes(i).p1.y = D(i).y0
       Cubes(i).p1.z = D(i).z0

       Cubes(i).p2.x = D(i).x0 + w
       Cubes(i).p2.y = D(i).y0
       Cubes(i).p2.z = D(i).z0

       Cubes(i).p3.x = D(i).x0 + w
       Cubes(i).p3.y = D(i).y0 + h
       Cubes(i).p3.z = D(i).z0

       Cubes(i).p4.x = D(i).x0
       Cubes(i).p4.y = D(i).y0 + h
       Cubes(i).p4.z = D(i).z0

       Cubes(i).p5.x = D(i).x0
       Cubes(i).p5.y = D(i).y0
       Cubes(i).p5.z = D(i).z0 + z

       Cubes(i).p6.x = D(i).x0 + w
       Cubes(i).p6.y = D(i).y0
       Cubes(i).p6.z = D(i).z0 + z

       Cubes(i).p7.x = D(i).x0 + w
       Cubes(i).p7.y = D(i).y0 + h
       Cubes(i).p7.z = D(i).z0 + z

       Cubes(i).p8.x = D(i).x0
       Cubes(i).p8.y = D(i).y0 + h
       Cubes(i).p8.z = D(i).z0 + z

       Cubes(i).Color = D(i).clr
   Next j

End Sub

Sub CreateSubDividedCubes (C As Cube, iColor As Long)
    Local i,j,k As Long, tempC As Cube

    For i = 1 To UBound(xpoints)
        If xpoints(i) <  c.p1.x Then Iterate For
        If xpoints(i) >= c.p2.x Then Exit For

        For j = 1 To UBound(ypoints)
            If ypoints(j) <  c.p1.y Then Iterate For
            If ypoints(j) >= c.p4.y Then Exit For

            For k = 1 To UBound(zpoints)
                If zpoints(k) < c.p1.z Then Iterate For
                If zpoints(k) >= c.p5.z Then Exit For

            'create cube with boundaries
            tempC.p1.x = xpoints(i)
            tempC.p1.y = ypoints(j)
            tempC.p1.z = zpoints(k)

            tempC.p2.x = xpoints(i+1)
            tempC.p2.y = ypoints(j)
            tempC.p2.z = zpoints(k)

            tempC.p3.x = xpoints(i+1)
            tempC.p3.y = ypoints(j+1)
            tempC.p3.z = zpoints(k)

            tempC.p4.x = xpoints(i)
            tempC.p4.y = ypoints(j+1)
            tempC.p4.z = zpoints(k)

            tempC.p5.x = xpoints(i)
            tempC.p5.y = ypoints(j)
            tempC.p5.z = zpoints(k+1)

            tempC.p6.x = xpoints(i+1)
            tempC.p6.y = ypoints(j)
            tempC.p6.z = zpoints(k+1)

            tempC.p7.x = xpoints(i+1)
            tempC.p7.y = ypoints(j+1)
            tempC.p7.z = zpoints(k+1)

            tempC.p8.x = xpoints(i)
            tempC.p8.y = ypoints(j+1)
            tempC.p8.z = zpoints(k+1)

            CreatePointsTriangleFromSubDividesCubes tempC, iColor

            Incr BlockExtCount

    Next k
    Next j
    Next i

End Sub

Sub CreatePointsTriangleFromSubDividesCubes(C As Cube, iColor As Long)
   Local i,j,k As Long
   j = UBound(P)
   ReDim Preserve P(j+8)
   ReDim Preserve POnly(j+8)
   For i = j+1 To j+8 : P(i).Color = iColor : Next i
   P(j+1).x = C.P1.x  : P(j+1).y = C.P1.y  : P(j+1).z = C.P1.z
   P(j+2).x = C.P2.x  : P(j+2).y = C.P2.y  : P(j+2).z = C.P2.z
   P(j+3).x = C.P3.x  : P(j+3).y = C.P3.y  : P(j+3).z = C.P3.z
   P(j+4).x = C.P4.x  : P(j+4).y = C.P4.y  : P(j+4).z = C.P4.z
   P(j+5).x = C.P5.x  : P(j+5).y = C.P5.y  : P(j+5).z = C.P5.z
   P(j+6).x = C.P6.x  : P(j+6).y = C.P6.y  : P(j+6).z = C.P6.z
   P(j+7).x = C.P7.x  : P(j+7).y = C.P7.y  : P(j+7).z = C.P7.z
   P(j+8).x = C.P8.x  : P(j+8).y = C.P8.y  : P(j+8).z = C.P8.z

   k = UBound(T)
   ReDim Preserve T(k+12)
   For i = k+1 To k+12 : T(i).Color = iColor : Next i
   T(k+1).p1 = j+1 : T(k+1).p2 = j+4 : T(k+1).p3 = j+3
   T(k+2).p1 = j+1 : T(k+2).p2 = j+3 : T(k+2).p3 = j+2
   T(k+3).p1 = j+5 : T(k+3).p2 = j+1 : T(k+3).p3 = j+2
   T(k+4).p1 = j+5 : T(k+4).p2 = j+2 : T(k+4).p3 = j+6
   T(k+5).p1 = j+8 : T(k+5).p2 = j+5 : T(k+5).p3 = j+6
   T(k+6).p1 = j+8 : T(k+6).p2 = j+6 : T(k+6).p3 = j+7
   T(k+7).p1 = j+4 : T(k+7).p2 = j+8 : T(k+7).p3 = j+7
   T(k+8).p1 = j+4 : T(k+8).p2 = j+7 : T(k+8).p3 = j+3
   T(k+9).p1 = j+3 : T(k+9).p2 = j+7 : T(k+9).p3 = j+6
   T(k+10).p1 = j+3 : T(k+10).p2 = j+6 : T(k+10).p3 = j+2
   T(k+11).p1 = j+4 : T(k+11).p2 = j+1 : T(k+11).p3 = j+5
   T(k+12).p1 = j+4 : T(k+12).p2 = j+5 : T(k+12).p3 = j+8

   For i = j To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
    Next i

    Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Unique Points: " + Str$(UniquePointCount) + "      Triangles: " + Str$(UBound(T)) + "      BlocksExt: " + Str$(BlockExtCount) + "      Blocks: " + Str$(UBound(D))
End Sub

Sub ResizeDialog
   If IsIconic(hDlg) Then Exit Sub
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   h = h - 20  'minus height of statusbar
   If ShowData Then
      Control Set Size hDlg, %IDC_TextBox, 340,h-120
      Control Set Size hDlg, %IDC_Graphic, w-350,h-65
      OffsetX = (w-350)/2  :  OffsetY = (h-65)/2
   Else
      Control Set Size hDlg, %IDC_Graphic, w,h-65
      OffsetX = w/2  :  OffsetY = (h-65)/2
   End If
End Sub

Sub ManageVisibleControls
   If ShowData Then
      Control Show State hDlg, %IDC_TextBox, %SW_Show
      Control Show State hDlg, %IDC_Label, %SW_Show
      Control Set Loc hDlg, %IDC_Graphic, 350,60
   Else
      Control Show State hDlg, %IDC_TextBox, %SW_Hide
      Control Show State hDlg, %IDC_Label, %SW_Hide
      Control Set Loc hDlg, %IDC_Graphic, 0,60
   End If
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowData, ShowData * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Points, IIf(DisplayType=1,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Lines, IIf(DisplayType=2,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Surfaces, IIf(DisplayType=3,1,0) * %TBState_Checked Or %TBState_Enabled

   'Menus
    Menu Set State hSettings, ByCmd %IDM_RotateAboutXAxis, RotateX * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_RotateAboutYAxis, RotateY * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_DepthSort, DepthSort * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_BackFace, BackFace * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ShowLines, ShowLines * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoScale, AutoScale * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_PGradient, PGradient * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_TGradient, IIf(TColorScheme = %TGradient,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_TBlocks, IIf(TColorScheme = %TBlocks,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_TDefault, IIf(TColorScheme = %TDefault,1,0) * %MFS_Checked Or %MFS_Enabled

End Sub

Function NewTextProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long
   Select Case Msg
      Case %WM_MouseWheel
         Select Case Hi(Integer,WParam)    'note the use of Integer
           Case > 0
              ChangeSize 1
              PipeLine
           Case < 0
              ChangeSize -1
              PipeLine
         End Select
      Case %WM_ContextMenu
         SetFocus WParam
         x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
         Select Case PathName$(Extn,CurrentFileName)
            Case "",".stla",".stlb"
               Beep  'do nothing - no context menu
            Case Else
               TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         End Select
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OrigTextProc, hWnd, Msg, wParam, lParam)
End Function

Function NewGraphicProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case Msg
      Case %WM_MouseWheel
         Select Case Hi(Integer,WParam)    'note the use of Integer
           Case > 0
              ChangeSize 1
              PipeLine
           Case < 0
              ChangeSize -1
              PipeLine
         End Select
   End Select
   Function = CallWindowProc(OrigGraphicProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Apply Edited Scene Data" + $Tab + "Ctrl-A", %IDM_ApplySceneData,  %MF_Enabled
   Menu Add String, hContext, "Reload Scene Data File" + $Tab + "Ctrl-R", %IDM_ReloadSceneDataFile,  %MF_Enabled
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub SaveSceneDataToCurrentFileName
    If CurrentFileName = "<sphere>"  Or LCase$(PathName$(Extn,CurrentFileName)) = ".stla"  Or LCase$(PathName$(Extn,CurrentFileName)) = ".stlb" Then
       Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Cannot save <sphere> or STL files!"
       Beep : Exit Sub
    End If
   Local temp$, i As Long
   temp$ = "gbBlocks3D"
   For i = 1 To UBound(D)
      temp$ = temp$ + $CrLf + LTrim$(Str$(D(i).x0)) + ", " + Str$(D(i).y0) + ", " + Str$(D(i).z0) + ", " + _
      Str$(D(i).w) + ", " + Str$(D(i).h) + ", " + Str$(D(i).z) + ", " + Str$(D(i).clr) + ", " + Str$(D(i).trans)
   Next i
   temp$ = Trim$(temp$,Any $CrLf+$Spc)
   Open CurrentFileName For Output As #1
   Print #1, temp$
   Close #1
End Sub

Sub SaveAs
    If CurrentFileName = "<sphere>"  Or LCase$(PathName$(Extn,CurrentFileName)) = ".stla"   Or LCase$(PathName$(Extn,CurrentFileName)) = ".stlb" Then
       Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Cannot save <sphere> or STL files!"
       Beep : Exit Sub
    End If
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""                'caption title. if "", then "Save As" is displayed
    startfolder$ = Exe.Path$ + "scenes"    'initial folder to be displayed
    filter$ = "gbFloorPlanner Layout Files" + $Nul + "*.dat" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = CurrentFileName  'name to be used as initial selection
    defaultext$ = "txt"           'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       CurrentFileName = filevar$
       SaveSceneDataToCurrentFileName
       Dialog Set Text hDlg, "gbBlocks3D   v" + $ver + "     " + CurrentFileName
    End If
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "scenes") = %False Then MkDir Exe.Path$ + "scenes"
End Sub

Function SelectFileToOpen() As String
    Local title$,startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Open"
    filter$ = "gbBlocks3D Scenes (including STL files)" + $Nul + "*.*" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    If IsFile(CurrentFileName) Then
       startfolder$ = CurrentFileName      'initial folder to be displayed
       startfile$ = CurrentFileName        'name to be used as initial selection
    Else
       startfolder$ = Exe.Path$ + "scenes"      'initial folder to be displayed
       startfile$ = ""                          'name to be used as initial selection
    End If
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    defaultext$ = "txt"
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$
End Function

Sub LoadSTLAFile (fName As String)

    Local temp As String, i, iCount, iPoints, iTriangles As Long

    'verify file is right type
    Open fName For Input As #1
    Line Input #1, temp
    Close #1
    If Left$(LCase$(Trim$(temp)),5) <> "solid" Then Exit Sub

    'get count # Points and # triangles
    Open fName For Binary As #1
    Get$ #1, Lof(1), temp
    Close #1
    iCount = ParseCount(LCase$(temp), "endfacet") - 1
    ReDim P(iCount*3), POnly(iCount*3), T(iCount)

    'load into P(), POnly(), T()
    Open fName For Input As #1
    Line Input #1, temp    'header, discard
    For i = 1 To iCount
        Incr iTriangles

        Line Input #1, temp 'discard
        Line Input #1, temp 'discard

        Line Input #1, temp 'p1
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p1 = iPoints

        Line Input #1, temp 'p2
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p2 = iPoints

        Line Input #1, temp 'p3
           temp = Trim$(temp)
           Incr iPoints
           While InStr(temp, "  ") : Replace "  " With " " In temp : Wend   'remove extra spaces
           P(iPoints).x = Val(Parse$(temp," ",2)) : POnly(iPoints).x = P(iPoints).x
           P(iPoints).y = Val(Parse$(temp," ",3)) : POnly(iPoints).y = P(iPoints).y
           P(iPoints).z = Val(Parse$(temp," ",4)) : Ponly(iPoints).z = P(iPoints).z
           T(iTriangles).p3 = iPoints

        Line Input #1, temp ' discard
        Line Input #1, temp ' discard

    Next i
    Close #1

   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i


   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub

Function UniquePointCount() As Long
   Local i,pCount As Long

   'make duplicate file
   ReDim tempP(UBound(P)) As PointX
   For i = 0 To UBound(P) : tempP(i) = P(i) : Next i

   Array Sort tempP(1), Call CustomAllPointSort
   For i = UBound(tempP) To 1 Step -1
      If tempP(i) <> tempP(i-1) Then Incr pCount
   Next i

   Function = pCount
End Function

Function CustomAllPointSort(R As PointX, S As PointX) As Long
   'sorts in ascending order by xyz elements
   If R.z < S.z Then Function = -1 : Exit Function
   If R.z > S.z Then Function = +1 : Exit Function
   If R.y < S.y Then Function = -1 : Exit Function
   If R.y > S.y Then Function = +1 : Exit Function
   If R.x < S.x Then Function = -1 : Exit Function
   If R.x > S.x Then Function = +1 : Exit Function
End Function

Sub LoadSTLBFile (fName As String)
   Local temp As String * 80
   Local x,y,z As Single
   Local i, iPoints As Long
   Local iCount As Dword
   Local iSkip As Integer

   Open fName For Binary As #1
   Get #1, , temp
   Get #1, , iCount
   ReDim P(iCount*3), POnly(iCount*3), T(iCount)

   For i = 1 To iCount
       Get #1, , x : Get #1, , y : Get #1, , z  'discard

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p1 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p2 = iPoints

       Incr iPoints
       Get #1, , P(iPoints).x : Get #1, , P(iPoints).y : Get #1, , P(iPoints).z
       T(i).p3 = iPoints

       Get #1, , iSkip
   Next i
   Close #1
   For i = 1 To UBound(P)
      P(i).xo = P(i).x : POnly(i).x = P(i).x
      P(i).yo = P(i).y : POnly(i).y = P(i).y
      P(i).zo = P(i).z : POnly(i).z = P(i).z
   Next i
   SetPointGradientColors
   SetTriangleGradientColors
   CreateOriginalPTString
End Sub
